function stubGenerationMetaInfo(wsdlVersion, serviceName) {

    if (!wsdlVersion) {
        wsdlVersion = "1.1";
    }

    var wsdlLocation;
    if (wsdlVersion == "1.1") {
        wsdlLocation = HTTP_URL + '/' + serviceName + '?wsdl';
    } else {
       wsdlLocation = HTTP_URL + '/' + serviceName + '?wsdl2';
    }

    var buttonObj = document.getElementById('dynamicClientButtonId');
    if (buttonObj != null) {
        buttonObj.disabled=true;
    }

    var body_xml = '<req:listServicesAndPortsRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '<serviceName>' + serviceName + '</serviceName>\n' +
                   '<wsdlVersion>' + wsdlVersion + '</wsdlVersion>\n'+
                   '<wsdlLocation>' + wsdlLocation+ '</wsdlLocation>\n' +
                   '</req:listServicesAndPortsRequest>\n';

    var callURL = serverURL + "/" + "WsdlInfoService" + "/" ;
    wso2.wsf.Util.cursorWait();
    new wso2.wsf.WSRequest(callURL, "listServicesAndPorts", body_xml, stubGenerationMetaInfoCallback);
}

function stubGenerationMetaInfoCallback() {

    wso2.wsf.Util.callbackhelper(this.req.responseXML,"stub_meta_info.xsl",
                                 document.getElementById("divStubGeneration"));
    document.getElementById("breadcrumbDiv").style.display = 'inline';
   // showstubGenMetaInfo(document.getElementById('stubGenMetaInfo'));
}

function stubGenerationSOAPRequest(packageNameObj, invocationStyleObj,
                                   generateTestCasesObj, databindingMethodObj,
                                   unpackClassesObj, serviceBindingName,
                                   serviceBindingPortObj, unwrapObj, wsdlVersionObj) {

    var packageName = packageNameObj.value;
    var invocationStyle = invocationStyleObj[invocationStyleObj.selectedIndex].value;
    var generateTestCases = generateTestCasesObj[generateTestCasesObj.selectedIndex].value;
    var databindingMethod = databindingMethodObj[databindingMethodObj.selectedIndex].value;
    var unpackClasses = unpackClassesObj[unpackClassesObj.selectedIndex].value;
    var serviceBindingPort = serviceBindingPortObj[serviceBindingPortObj.selectedIndex].value;
    var unwrap = unwrapObj[unwrapObj.selectedIndex].value;
    var wsdlVersion = wsdlVersionObj[wsdlVersionObj.selectedIndex].value;

    var pattern = /^[a-zA-Z](([a-zA-Z_]+)([a-zA-Z0-9_]?)\.?)+[a-z0-9_]$/;
    if (packageName == null || wso2.wsf.Util.trim(packageName) == '') {
        wso2.wsf.Util.alertWarning("Package name is mandatory");
        return;
    }
    if (!pattern.test(packageName)) {
        wso2.wsf.Util.alertWarning("Package name is not valid under Java package naming conventions");
        return;
    }

    var wsdlLocation;
    if (wsdlVersion == "1.1") {
        wsdlLocation = HTTP_URL + '/' + serviceBindingName + '?wsdl';
    } else {
       wsdlLocation = HTTP_URL + '/' + serviceBindingName + '?wsdl2';
    }

    var buttonObj = document.getElementById('dynamicClientButtonId');
    if (buttonObj != null) {
        buttonObj.disabled = true;
    }

    var body_xml = ' <req:generateRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <service>' + serviceBindingName + '</service>\n' +
                   ' <packageName>' + packageName + '</packageName>\n' +
                   ' <invocationStyle>' + invocationStyle + '</invocationStyle>\n' +
                   ' <generateTestCase>' + generateTestCases + '</generateTestCase>\n' +
                   ' <databindingMethod>' + databindingMethod + '</databindingMethod>\n' +
                   ' <unpackClasses>' + unpackClasses + '</unpackClasses>\n' +
                   ' <serviceBindingName>' + serviceBindingName + '</serviceBindingName>\n' +
                   ' <servicePortName>' + serviceBindingPort + '</servicePortName>\n' +
                   ' <unwrap>' + unwrap + '</unwrap>\n' +
                   ' <wsdlVersion>' + wsdlVersion + '</wsdlVersion>\n' +
                   ' <wsdlLocation>' + wsdlLocation + '</wsdlLocation>\n' +
                   ' </req:generateRequest>\n';

    var callURL = serverURL + "/" + "JavaClientGeneratorService" ;
    wso2.wsf.Util.cursorWait();
    new wso2.wsf.WSRequest(callURL, "generate", body_xml, generateCallBack);
}

function generateCallBack() {

    //response will be a link and it will call the download dialog
    var data = this.req.responseXML;

    var responseTextValue = data.getElementsByTagName("return")[0].firstChild.nodeValue;

    var buttonObj = document.getElementById('dynamicClientButtonId');
    if (buttonObj != null) {
        buttonObj.disabled = false;
    }

    window.location = URL + responseTextValue;
    document.getElementById("breadcrumbDiv").style.display = 'inline';
}