/*
log.js contains scripts need to handle log information.
*/

var LOG_VIEWER_SERVICE = "LogViewer"

function viewLogs() {
    var body_xml = '<ns1:getLogsRequest xmlns:ns1="http://org.apache.axis2/xsd">' +
                   '</ns1:getLogsRequest>';
    var callURL = serverURL + "/" + LOG_VIEWER_SERVICE + "/" + "getLogs";
    new wso2.wsf.WSRequest(callURL, "getLogs", body_xml, viewLogsCallback);
}

function viewLogsCallback() {
    var t = document.getElementById("viewlogs");
    wso2.wsf.Util.callbackhelper(this.req.responseXML, "viewlog.xsl", document.getElementById("viewlogs"));
    generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Logs");
}


function viewSingleLogLevel() {
    var loglevel = document.getElementById("logLevelID");
    var loglevel_index = null;
    var loglevel_value = null;
    if (loglevel != null)
    {
        loglevel_index = loglevel.selectedIndex;
        if (loglevel_index != null) {
            loglevel_value = loglevel.options[loglevel_index].value;
        }
    }
    if (loglevel_value != null && loglevel_value != "") {
        var body_xml = '<ns1:getLogsForSingleLogLevel xmlns:ns1="http://org.apache.axis2/xsd">' +
                       '<type>' + loglevel_value + '</type>' +
                       '</ns1:getLogsForSingleLogLevel>';
        var callURL = serverURL + "/" + LOG_VIEWER_SERVICE + "/" + "getLogsForSingleLogLevel";
        new wso2.wsf.WSRequest(callURL, "getLogsForSingleLogLevel", body_xml, searchLogCallback);
    } else {
        return;
    }

}
function submitenter(e)
{
    var keycode;
    if (window.event) {
        keycode = window.event.keyCode;
    }
    else if (e) {
        keycode = e.which;
    }
    if (keycode == 13)
    {
        searchLog();
        return true;
    }
    else {
        return true;
    }
}
function searchLog() {
    var loglevel = document.getElementById("logLevelID");
    var loglevel_index = null;
    var loglevel_value = null;
    if (loglevel != null)
    {
        loglevel_index = loglevel.selectedIndex;
        if (loglevel_index != null) {
            loglevel_value = loglevel.options[loglevel_index].value;
        }
    }
    var keyword = document.getElementById("logkeyword");
    if (keyword != null && keyword != undefined && keyword.value != null && keyword.value != undefined) {
        if (keyword.value == "") {
            viewLogs();
        } else {
            var body_xml = '<ns1:searchLogRequest xmlns:ns1="http://org.apache.axis2/xsd">' +
                           '<type>' + loglevel_value + '</type>' +
                           '<kerword>' + keyword.value + '</kerword>' +
                           '</ns1:searchLogsRequest>';
            var callURL = serverURL + "/" + LOG_VIEWER_SERVICE + "/" + "searchLog";
            new wso2.wsf.WSRequest(callURL, "searchLog", body_xml, searchLogCallback);
        }
    } else {
        return;
    }
}
function searchLogCallback() {
    var objDiv = document.getElementById("viewlogs");
    var keyword = document.getElementById("logkeyword");
    var loglevel = document.getElementById("logLevelID");
    var data = getNodeFromPath("return", this.req.responseXML);
    var loglevel_index = null;
    var loglevel_value = null;
    if (loglevel != null)
    {
        loglevel_index = loglevel.selectedIndex;
        if (loglevel_index != null) {
            loglevel_value = loglevel.options[loglevel_index].value;
        }
    }
    if (loglevel_value != null && loglevel_value != "") {
        data.setAttribute("level", loglevel_value)
    }
    if (keyword != null && keyword.value != undefined) {
        data.setAttribute("keyword", keyword.value)
    }
    var logdiv = document.getElementById("logdiv");
    wso2.wsf.Util.processXML(data, "viewlog.xsl", objDiv);
    wso2.wsf.Util.showOnlyOneMain(objDiv);
    document.getElementById("breadcrumbDiv").style.display = 'inline';
}
function clearLogEntries() {
    var body_xml = '<ns1:clearLogsRequest xmlns:ns1="http://org.apache.axis2/xsd">' +
                   '</ns1:clearLogsRequest>';
    var callURL = serverURL + "/" + LOG_VIEWER_SERVICE + "/" + "clearLogs";
    new wso2.wsf.WSRequest(callURL, "clearLogs", body_xml, clearLogEntriesCallback);
}
function clearLogEntriesCallback() {
    wso2.wsf.Util.callbackhelper(this.req.responseXML, "viewlog.xsl", document.getElementById("viewlogs"));
    document.getElementById("breadcrumbDiv").style.display = 'inline';
}
