<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:ns="http://org.apache.axis2/xsd"
                exclude-result-prefixes="ns">

    <xsl:output method="html" indent="yes"/>

    <xsl:template match="ns:getAvailableDSResponse">
        <h2>Edit Data Services</h2>
        <xsl:variable name="countDSNames" select="count(return)"/>
        <xsl:choose>
            <xsl:when test="$countDSNames &gt; 0">
                <table class="styled">
                    <thead>
                        <tr>
                            <th>Data Services</th>
                        </tr>
                    </thead>
                    <tbody>
                        <xsl:apply-templates select="return"/>
                    </tbody>
                </table>
            </xsl:when>
            <xsl:otherwise>
                <h3>There are no data services to be edited</h3>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

    <xsl:template match="return">
        <tr>
            <td>
                <a href="#">
                    <xsl:attribute name="onclick">configureDataservice('<xsl:value-of select="."/>'); return false;</xsl:attribute>
                    <xsl:value-of select="."/>
                </a>
            </td>
        </tr>
    </xsl:template>


</xsl:stylesheet>