<%@ page import="org.wso2.registry.Resource" %>
<%@ page import="org.wso2.carbon.registry.service.RegistryService" %>
<%@ page import="org.wso2.registry.Registry" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.axis2.context.ConfigurationContextFactory" %>
<%@ page import="org.wso2.carbon.module.mgt.service.ModuleAdminServiceStub" %>
<%@ page import="org.wso2.carbon.module.mgt.xsd.ModuleMetaData" %>
<%@ page import="org.apache.axis2.client.Options" %>
<%@ page import="org.apache.axis2.client.ServiceClient" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
    <title>Global Modules</title>
    <link href="../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript" src="../main/admin/js/main.js"></script>
    <script language="javascript" src="../main/admin/js/breadcrumbs.js"></script>
    <script language="javascript" src="../main/admin/js/cookies.js"></script>
</head>

<%
    String allModules = "", globalModules = "";
    RegistryService registryService = (RegistryService) config
            .getServletContext().getAttribute("registry");
    Registry systemRegistry = registryService.getSystemRegistry();
    Resource resource = systemRegistry.get("/carbon/connection/props");
    String servicePath = resource.getProperty("service-path");
    String contextRoot = resource.getProperty("context-root");
    String host = resource.getProperty("host-name");
    contextRoot = contextRoot.equals("/") ? "" : contextRoot;
    host = (host == null) ? "localhost" : host;
    String httpPort = System.getProperty("carbon.https.port");

    ConfigurationContext cc = ConfigurationContextFactory.createConfigurationContextFromFileSystem(null, null);
    ModuleAdminServiceStub stub = new ModuleAdminServiceStub(cc, "https://" + host + ":" +
            httpPort + "/" + contextRoot + servicePath + "/ModuleAdminService");
    
    String cookie = (String)session.getAttribute(org.wso2.carbon.utils.ServerConstants.ADMIN_SERVICE_COOKIE);
    ServiceClient client = stub._getServiceClient();
    Options option = client.getOptions();
    option.setManageSession(true);
    option.setProperty(org.apache.axis2.transport.http.HTTPConstants.COOKIE_STRING, cookie);
    

    ModuleMetaData[] data = stub.listModules();
    String link = "#", moduleName, status, button_name;

    for (ModuleMetaData aData : data) {
        moduleName = aData.getModulename();
        if (Boolean.parseBoolean(aData.getEngaged())) {
            button_name = "module_dis-engage_link";
            status = "engaged";
        } else {
            button_name = "module_engage_link";
            status = "disengaged";
        }
        if (moduleName.equals("wso2throttle")) {
            link = "../throttle/index.jsp";
        } else if (moduleName.equals("wso2caching")) {
            link = "../caching/index.jsp";
//            continue;
        }
        allModules += "<tr><td>" + aData.getModulename() + "</td><td>"
                + aData.getModuleVersion() + "</td><td>" + aData.getDescription() + "</td><td>&#160;&#160;&#160;&#160;"
                + "<a id=\"" + button_name + "\" href=\"" + link + "\" onclick=\"addToHistory();\""
                + "title=\"Configure " + moduleName + " module\n (Currently " + status + ")\" alt=\"Configure "
                + moduleName + " module\">&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;</a></td></tr>";
    }

    data = stub.listGloballyEngagedModules();

    for (ModuleMetaData aData : data) {
        globalModules += "<tr><td>" + aData.getModulename() + "-" + aData.getModuleVersion() + "</td><tr>";
    }
%>

<script language="javascript">

    function setBreadcrumb() {
        generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Global");
    }

    function addToHistory() {
        updateHistory("Global", self.location.toString(), "jsp");
    }

</script>

<body onload="setBreadcrumb();">
<div id="middle">
    <div id="breadcrumbDiv" style="display:none;"></div>

    <h2>Global Configurations</h2>
    <table width="100%" border="0" cellpadding="0" cellspacing="0">
		<tr>
            <a id="help_link" alt="" title="Help" onclick="showHelp();" href="#">&#160;&#160;&#160;&#160;&#160;&#160;&#160;Help</a>
        </tr>
	</table>
    <p>&nbsp;</p>

    <div id="formset">
        <form id="form3" name="dataForm" method="post" action="">
            <fieldset>
                <p>
                    <legend>Available Modules</legend>
                </p>
                <table class="styled">
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Version</th>
                            <th>Description</th>
                            <th>Actions</th>
                        </tr>
                    </thead>
                    <%= allModules%>
                </table>
            </fieldset>

            <p>&nbsp;</p>

            <fieldset>
                <p>
                    <legend>Globally Engaged Modules</legend>
                </p>
                <table class="styled">
                    <thead>
                        <tr>
                            <th>Engaged Modules</th>
                        </tr>
                    </thead>
                    <%= globalModules%>
                </table>
            </fieldset>
        </form>
    </div>
</div>

<div id="alertMessageBox" style="display:none;position:absolute;z-index: 600;">
    <!--the message area-->
    <p id="alertMessageBoxMessageArea"></p>
    <!-- the button area-->
    <p id="alertButton" align="right">
        <input id="alertBoxButton" type="button"
               value="  OK  "
               onclick="document.getElementById('alertMessageBox').style.display='none';return false;"/>
    </p>
</div>
</body>
</html>
