<!--
/*
* Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
* http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/
-->

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
    <link href="../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript" src="../main/admin/js/breadcrumbs.js"></script>
    <script language="javascript" src="../main/admin/js/cookies.js"></script>
    <script language="javascript" src="../main/admin/js/main.js"></script>
    <title>Caching</title>
</head>

<%@ page import="org.wso2.carbon.caching.service.CachingAdminServiceStub" %>
<%@ page import="org.wso2.carbon.caching.xsd.CachingConfigData" %>
<%@ page import="org.wso2.registry.Registry" %>
<%@ page import="org.wso2.carbon.registry.service.RegistryService" %>
<%@ page import="org.wso2.registry.Resource" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.axis2.context.ConfigurationContextFactory" %>
<%@ page import="org.apache.axis2.client.Options" %>
<%@ page import="org.apache.axis2.client.ServiceClient" %>
<%
    String serviceName = request.getParameter("serviceName");

    String param = "", header;
    boolean global = false;
    if (serviceName == null) {
        global = true;
        header = "Global Caching Configuration";
    } else {
        param = "serviceName=" + serviceName;
        header = "Caching Configuration for " + serviceName + " Service";
    }

    RegistryService registryService = (RegistryService) config
            .getServletContext().getAttribute("registry");
    Registry systemRegistry = registryService.getSystemRegistry();
    Resource resource = systemRegistry.get("/carbon/connection/props");
    String servicePath = resource.getProperty("service-path");
    String contextRoot = resource.getProperty("context-root");
    String host = resource.getProperty("host-name");
    contextRoot = contextRoot.equals("/") ? "" : contextRoot;
    host = (host == null) ? "localhost" : host;
    String httpPort = System.getProperty("carbon.https.port");

    ConfigurationContext cc = ConfigurationContextFactory.createConfigurationContextFromFileSystem(null, null);
    CachingAdminServiceStub stub = new CachingAdminServiceStub(cc, "https://" + host + ":" +
                                                                   httpPort + "/" + contextRoot + servicePath + "/CachingAdminService");

    String cookie = (String)session.getAttribute(org.wso2.carbon.utils.ServerConstants.ADMIN_SERVICE_COOKIE);
    ServiceClient client = stub._getServiceClient();
    Options option = client.getOptions();
    option.setManageSession(true);
    option.setProperty(org.apache.axis2.transport.http.HTTPConstants.COOKIE_STRING, cookie);

    String visibility = "display: none;";
    String op1;
    String op2;         
    boolean cachingEnabled;
    CachingConfigData confData;
    if (global) {
        cachingEnabled = stub.isCachingGloballyEnabled();
        confData = stub.getGlobalCachingPolicy();
    } else {
        cachingEnabled = stub.isCachingEnabled(serviceName);
        confData = stub.getCachingPolicyForService(serviceName);
    }
    if (cachingEnabled) {
        op1 = "Yes";
        op2 = "No";
        visibility = "display: inline;";
    } else {
        op1 = "No";
        op2 = "Yes";
    }
    String expTime = "", maxCacheSize = "", maxMsgSize = "";
    String xmlIdentifier = confData.getXmlIdentifier();
    if (confData.getExpTime() != 0) {
        expTime = String.valueOf(confData.getExpTime());
    }
    if (confData.getMaxCacheSize() != 0) {
        maxCacheSize = String.valueOf(confData.getMaxCacheSize());
    }
    if (confData.getMaxMsgSize() != 0) {
        maxMsgSize = String.valueOf(confData.getMaxMsgSize());
    }
%>

<script language="javascript">
    function submitData() {
        if (document.configForm.hashField.value == "") {
            wso2.wsf.Util.alertMessage("Hash Generator field can't be empty");
            return;
        }
        document.configForm.action = "update.jsp?<%= param%>";
        document.configForm.submit();
    }

    function reset() {
        document.configForm.enable.value = "<%= op1%>";
        document.configForm.hashField.value = "<%= xmlIdentifier%>";
        document.configForm.timeoutField.value = "<%= expTime%>";
        document.configForm.cacheField.value = "<%= maxCacheSize%>";
        document.configForm.msgField.value = "<%= maxMsgSize%>";
        display();
    }

    function clearAll() {
        document.configForm.hashField.value = "";
        document.configForm.timeoutField.value = "";
        document.configForm.cacheField.value = "";
        document.configForm.msgField.value = "";
    }

    function display() {
        var configDiv = document.getElementById("configDiv");
        var enableCombo = document.getElementById("enable");
        if (enableCombo.value == "Yes") {
            configDiv.style.display = "inline";
        } else {
            var answer = confirm(
                    "This will disengage caching from your service. Click OK to confirm.");
            if (answer) {
                configDiv.style.display = "none";
                if (<%= cachingEnabled%>) {
                    submitData();
                }
            } else {
                enableCombo.value = "Yes";
            }
        }
    }

    function setDefaults() {
        document.configForm.hashField.value = "org.wso2.caching.digest.DOMHASHGenerator";
        document.configForm.timeoutField.value = "60000";
        document.configForm.cacheField.value = "1000";
        document.configForm.msgField.value = "1000";
    }

    function setBreadcrumb() {
        generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Caching");
        prepareCancelButton(document.getElementById("cancelButton"));
    }

</script>

<body onload="setBreadcrumb();">
<jsp:include page="display-messages.jsp"/>
<div id="middle">
    <div id="breadcrumbDiv" style="display:none;"></div>

    <h2><%= header%></h2>
    <table width="100%" border="0" cellpadding="0" cellspacing="0">
		<tr>
            <a id="help_link" alt="" title="Help" onclick="showHelp();" href="#">&#160;&#160;&#160;&#160;&#160;Help</a>
        </tr>
	</table>
    <p>&nbsp;</p>

    <div id="formset">
    <form id="form1" name="configForm" method="post" action="">
        <table class="caching_style">
            <tr>
                <td>
                    Enable Caching?
                </td>
                <td>
                    <select id="enable" name="enable" onchange="display();">
                        <option value="<%= op1%>"><%= op1%>
                        </option>
                        <option value="<%= op2%>"><%= op2%>
                        </option>
                    </select>
                </td>
            </tr>
        </table>
        <p>&nbsp;</p>

        <div id="configDiv" style="<%= visibility%>">
            <table class="caching_style" width="800" border="0">
                <tr>
                    <td colspan="2">Hash Generator</td>
                    <td>
                        <input name="hashField" type="text" value="<%= xmlIdentifier%>"
                               size="80"/>
                    </td>
                </tr>
                <tr>
                    <td colspan="2">Timeout (ms)</td>
                    <td>
                        <input name="timeoutField" type="text" value="<%= expTime%>"/>
                    </td>
                </tr>
                <tr>
                    <td colspan="2">Memory Cache Size (bytes)</td>
                    <td>
                        <input name="cacheField" type="text" value="<%= maxCacheSize%>"/>
                    </td>
                </tr>
                <tr>
                    <td colspan="2">Max Message Size (bytes)</td>
                    <td>
                        <input name="msgField" type="text" value="<%= maxMsgSize%>"/>
                    </td>
                </tr>
                <tr>
                    <td colspan="3">&nbsp;</td>
                </tr>
                <tr>
                    <td colspan="2">&nbsp;</td>
                    <td>
                        <input type="button" Id="Submit" name="Submit" value="Finish"
                               onclick="submitData();"/>
                        <input type="button" Id="Reset" name="Reset" value="Reset"
                               onclick="reset();"/>
                        <input type="button" Id="Default" name="Default" value="Default"
                               onclick="setDefaults();"/>
                        <input type="button" Id="Clear" name="Clear" value="Clear"
                               onclick="clearAll();"/>
                        <a id="cancelButton" href="#"><input type="button" value="Cancel"/></a>
                    </td>
                </tr>
            </table>
        </div>
    </form>
</div>
    </div>

<div id="alertMessageBox" style="display:none;position:absolute;z-index: 600;">
    <!--the message area-->
    <p id="alertMessageBoxMessageArea"></p>
    <!-- the button area-->
    <p id="alertButton" align="right">
        <input id="alertBoxButton" type="button"
               value="  OK  "
               onclick="document.getElementById('alertMessageBox').style.display='none';return false;"/>
    </p>
</div>
</body>
</html>
