<%@ page import="org.wso2.carbon.throttle.service.ThrottleAdminServiceStub" %>
<%@ page import="org.wso2.carbon.throttle.xsd.ThrottlePolicy" %>
<%@ page import="org.wso2.carbon.throttle.xsd.InternalData" %>
<%@ page import="org.wso2.registry.Resource" %>
<%@ page import="org.wso2.carbon.registry.service.RegistryService" %>
<%@ page import="org.wso2.registry.Registry" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.axis2.context.ConfigurationContextFactory" %>
<%@ page import="org.apache.axis2.client.Options" %>
<%@ page import="org.apache.axis2.client.ServiceClient" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
    <title>Carbon Throttle</title>
    <link href="../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript" src="../main/admin/js/main.js"></script>
    <script language="javascript" src="../main/admin/js/breadcrumbs.js"></script>
    <script language="javascript" src="../main/admin/js/cookies.js"></script>
</head>

<%
    String service = request.getParameter("serviceName");
    String param = "", header;
    boolean global = false;
    if (service == null) {
        global = true;
        header = "Global Throttling Configuration";
    } else {
        param = "serviceName=" + service;
        header = "Throttling Configuration for " + service + " Service";
    }
    /**
     * Get the current policy configuration from the admin service to
     * show when index.jsp loads.
     */
    RegistryService registryService = (RegistryService) config
            .getServletContext().getAttribute("registry");
    Registry systemRegistry = registryService.getSystemRegistry();
    Resource resource = systemRegistry.get("/carbon/connection/props");
    String servicePath = resource.getProperty("service-path");
    String contextRoot = resource.getProperty("context-root");
    String host = resource.getProperty("host-name");
    contextRoot = contextRoot.equals("/") ? "" : contextRoot;
    host = (host == null) ? "localhost" : host;
    String httpPort = System.getProperty("carbon.https.port");

    ConfigurationContext cc = ConfigurationContextFactory.createConfigurationContextFromFileSystem(null, null);
    ThrottleAdminServiceStub stub = new ThrottleAdminServiceStub(cc, "https://" + host + ":" +
            httpPort + "/" + contextRoot + servicePath + "/ThrottleAdminService");
    
    String cookie = (String)session.getAttribute(org.wso2.carbon.utils.ServerConstants.ADMIN_SERVICE_COOKIE);
    ServiceClient client = stub._getServiceClient();
    Options option = client.getOptions();
    option.setManageSession(true);
    option.setProperty(org.apache.axis2.transport.http.HTTPConstants.COOKIE_STRING, cookie);

    String loadDef = request.getParameter("loadDefault");

    ThrottlePolicy defThrottlePolicy = new ThrottlePolicy();
    InternalData[] defData = new InternalData[2];
    defThrottlePolicy.setInternalConfigs(defData);
    defData[0] = new InternalData();
    defData[0].setRange("other");
    defData[0].setRangeType("IP");
    defData[0].setAccessLevel(2);

    defData[1] = new InternalData();
    defData[1].setRange("other");
    defData[1].setRangeType("DOMAIN");
    defData[1].setAccessLevel(2);

    ThrottlePolicy policy;
    if (loadDef != null && loadDef.equals("true")) {
        //Set a default policy
        defThrottlePolicy.setEngaged(true);
        policy = defThrottlePolicy;
    } else {
        if (global) {
            policy = stub.getGlobalPolicyConfigs();
        } else {
            policy = stub.getPolicyConfigs(service);
        }
        if (!policy.getEngaged() && policy.getMaxConcurrentAccesses() == 0 &&
                (policy.getInternalConfigs() == null || policy.getInternalConfigs()[0] == null)) {
            policy = defThrottlePolicy;
        }
    }

    String maxAccesses = "";
    if (policy.getMaxConcurrentAccesses() != 0) {
        maxAccesses = String.valueOf(policy.getMaxConcurrentAccesses());
    }

    String firstOpt = "No", secondOpt = "Yes", htmlString = "", style = "display: none;", disableFields;
    int newRows = 0;

    //If the module is engaged, show the option as "Yes"
    if (policy.getEngaged()) {
        firstOpt = "Yes";
        secondOpt = "No";
        style = "display: inline;";
    }

    //If the incoming internal configs are not empty, load them
    if (policy.getMaxConcurrentAccesses() != 0 ||
            policy.getInternalConfigs() != null && policy.getInternalConfigs()[0] != null) {

        InternalData[] data = policy.getInternalConfigs();
        if (data != null) {
            newRows = data.length;

            String opt1, opt2, opt3, opt4, opt5;
            int f2, f3, f4;
            for (int i = 0; i < data.length; i++) {
                opt1 = "IP";
                opt2 = "DOMAIN";
                opt3 = "Control";
                opt4 = "Deny";
                opt5 = "Allow";
                disableFields = "";
                if (data[i] != null) {
                    if (data[i].getAccessLevel() == 1) {
                        opt3 = "Deny";
                        opt4 = "Control";
                        disableFields = "disabled=\'true\'";
                    } else if (data[i].getAccessLevel() == 2) {
                        opt3 = "Allow";
                        opt5 = "Control";
                        disableFields = "disabled=\'true\'";
                    }
                    if (data[i].getRangeType().equals("DOMAIN")) {
                        opt1 = "DOMAIN";
                        opt2 = "IP";
                    }
                    f2 = data[i].getMaxRequestCount();
                    f3 = data[i].getUnitTime();
                    f4 = data[i].getProhibitTimePeriod();
                    htmlString += "<tr>\n" +
                            "            <td><input name=\"data" + (i + 1) + "1\" type=\"text\" " +
                            "size=\"15\" value=\"" + data[i].getRange() + "\"/></td>\n" +
                            "            <td><select name=\"data" + (i + 1) + "6\">\n" +
                            "                <option value=\"" + opt1 + "\">" + opt1 + "</option>\n" +
                            "                <option value=\"" + opt2 + "\">" + opt2 + "</option>\n" +
                            "            </select></td>\n" +
                            "            <td><input size=\"13\" name=\"data" + (i + 1) + "2\" " + disableFields + " type=\"text\" " +
                            "value=\"" + ((f2 == 0) ? "" : f2) + "\"/></td>\n" +
                            "            <td><input size=\"13\" name=\"data" + (i + 1) + "3\" " + disableFields + " type=\"text\" " +
                            "value=\"" + ((f3 == 0) ? "" : f3) + "\"/></td>\n" +
                            "            <td><input size=\"14\" name=\"data" + (i + 1) + "4\" " + disableFields + " type=\"text\" " +
                            "value=\"" + ((f4 == 0) ? "" : f4) + "\"/></td>\n" +
                            "            <td><select onchange=\"checkForAllow(this);\" name=\"data" + (i + 1) + "5\">\n" +
                            "                <option value=\"" + opt3 + "\">" + opt3 + "</option>\n" +
                            "                <option value=\"" + opt4 + "\">" + opt4 + "</option>\n" +
                            "                <option value=\"" + opt5 + "\">" + opt5 + "</option>\n" +
                            "            </select></td>\n" +
                            "            <td>&#160;<a href=\"#\" id=\"cancel_link\" onclick=\"removeRow(this);\" title=\"Delete This Row\" alt=\"Delete\">&#160;&#160;&#160;&#160;&#160;</a></td>\n" +
                            "        </tr>\n";
                } else {
                    newRows--;
                }
            }
        }
    }
%>

<script language="javascript">

//set number of rows of the table at the back end
var rows = <%= newRows%>;

//Reset the names of the elements according to the order when needed
function resetIds(rowNumber) {
    var i;
    var j;
    var temp;
    for (i = rowNumber; i < rows; i++) {
        for (j = 1; j < 7; j++) {
            temp = document.getElementsByName("data" + (i + 1) + "" + j);
            temp[0].name = "data" + i + "" + j;
        }
    }
}

//add a new row to the table
function addRow() {
    rows = rows + 1;

    //add a row to the rows collection and get a reference to the newly added row
    var newRow = document.getElementById("dataTable").insertRow(-1);

    newRow.className = "even";

    //add 6 cells (<th>) to the new row and set the innerHTML to contain text boxes
    var oCell = newRow.insertCell(-1);
    oCell.innerHTML = "<input type='text' name='data" + rows + "1' size='15'/>";

    oCell = newRow.insertCell(-1);
    oCell.innerHTML = "<select name='data" + rows + "6'><option value='IP'>IP</option>" +
                      "<option value='DOMAIN'>DOMAIN</option></select>";

    oCell = newRow.insertCell(-1);
    oCell.innerHTML = "<input size='13' type='text' name='data" + rows + "2' disabled='true'/>";

    oCell = newRow.insertCell(-1);
    oCell.innerHTML = "<input size='13' type='text' name='data" + rows + "3' disabled='true'/>";

    oCell = newRow.insertCell(-1);
    oCell.innerHTML = "<input size='14' type='text' name='data" + rows + "4' disabled='true'/>";

    oCell = newRow.insertCell(-1);
    oCell.innerHTML = "<select onchange=\'checkForAllow(this);\' name='data" + rows + "5'><option value='Allow'>Allow</option>" +
                      "<option value='Deny'>Deny</option><option value='Control'>Control</option></select>";

    oCell = newRow.insertCell(-1);
    oCell.innerHTML = "&#160;<a href='#' id='cancel_link' onclick='removeRow(this);' title='Delete This Row' alt='Delete'>&#160;&#160;&#160;&#160;&#160;</a>";
}

//deletes the specified row from the table
function removeRow(src) {
    var oRow = src.parentNode.parentNode;
    var index = oRow.rowIndex;

    //once the row reference is obtained, delete it passing in its rowIndex
    document.getElementById("dataTable").deleteRow(oRow.rowIndex);

    //Reset the names as one row is deleted
    resetIds(index);
    rows = rows - 1;
}

function submitForm() {
    var i;
    var temp1, temp2, temp3;
    var rangeEmpty = false, controlError = false;
    for (i = 1; i < rows + 1; i++) {
        temp1 = document.getElementsByName("data" + i + "" + 1);
        if (temp1[0].value == "") {
            rangeEmpty = true;
            break;
        }
        temp1 = document.getElementsByName("data" + i + "" + 5);
        temp2 = document.getElementsByName("data" + i + "" + 2);
        temp3 = document.getElementsByName("data" + i + "" + 3);
        if (temp1[0].value == "Control" && (temp2[0].value == "" || temp3[0].value == "")) {
            controlError = true;
            break;
        }
    }
    if (rows == 0 && document.getElementById("maxAccess").value == "") {
        wso2.wsf.Util.alertMessage("Please provide policy configuration details before enabling Throttle");
    } else if (rangeEmpty) {
        wso2.wsf.Util.alertMessage("Range field can't be empty");
    } else if (controlError) {
        wso2.wsf.Util.alertMessage("When the Access Level is Control, Max Request Count and Unit time MUST be specified");
    } else {
        document.dataForm.action = "update.jsp?<%= param%>";
        document.dataForm.submit();
    }
}

//clear all the field on the UI
function clearAll() {
    document.getElementById("maxAccess").value = "";

    var i;
    var j;
    var temp;
    for (i = 1; i < rows + 1; i++) {
        for (j = 1; j < 7; j++) {
            temp = document.getElementsByName("data" + i + "" + j);
            if (j == 5) {
                temp[0].value = "Allow";
            } else if (j == 6) {
                temp[0].value = "IP";
            } else {
                temp[0].value = "";
            }
        }
    }
}

//make the configs visible
function showConfigs() {
    var temp = document.getElementById("policyConfiguration");
    if (document.getElementById("enableThrottle").value == "Yes") {
        temp.style.display = "inline";
    } else {
        temp.style.display = "none";
        var answer = confirm("This will disengage throttling from the " +
                             "service. Click OK to confirm");
        if (answer) {
            document.dataForm.action = "update.jsp?<%= param%>";
            document.dataForm.submit();
        } else {
            document.getElementById("enableThrottle").value = "Yes";
            showConfigs();
        }
    }
}

function checkForAllow(element) {
    var elName = element.name;
    var row = elName.substring(4, 5);
    var i;
    var temp;
    for (i = 2; i < 5; i++) {
        temp = document.getElementsByName("data" + row + "" + i);
        if (element.value == "Allow" || element.value == "Deny") {
            temp[0].disabled = true;
        } else {
            temp[0].disabled = false;
        }
    }
}

function resetForm() {
    document.dataForm.action = "index.jsp?<%= param%>";
    document.dataForm.submit();
}

function loadDefault() {
    document.dataForm.action = "index.jsp?loadDefault=true&<%= param%>";
    document.dataForm.submit();
}

function setBreadcrumb() {
    generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Throttling");
    prepareCancelButton(document.getElementById("cancelButton"));
}

//function showHelp() {
//    var myWindow = window.open("throttle_userguide.html", "tinyWindow", 'scrollbars=yes,menubar=no,height=600,width=600,resizable=yes,toolbar=no,location=no,status=no')
//    myWindow.focus()
//}

</script>

<body onload="setBreadcrumb();">
<jsp:include page="display-messages.jsp"/>
<div id="middle">
    <div id="breadcrumbDiv" style="display:none;"></div>

    <h2><%= header%></h2>
	<table width="100%" border="0" cellpadding="0" cellspacing="0">
		<tr>
			<%--<td class="helpNewSecurity"><a href="#" onclick="showHelp();"><img src="images/help.gif" border="0" /></a></td>--%>
			<%--<td class="helpNewSecurity" width="100%"><a href="#" onclick="showHelp();">Help</a></td>--%>
            <a id="help_link" alt="" title="Help" onclick="showHelp();" href="#">&#160;&#160;&#160;&#160;&#160;Help</a>
        </tr>
	</table>

    <p>&nbsp;</p>

    <div id="formset">
        <form id="form3" name="dataForm" method="post" action="">
            <table border="0">
                <tr>
                    <td>
                        Enable Throttling?
                    </td>
                    <td>
                        <select onchange="showConfigs();" id="enableThrottle" name="enable">
                            <option value="<%= firstOpt%>"><%= firstOpt%>
                            </option>
                            <option value="<%= secondOpt%>"><%= secondOpt%>
                            </option>
                        </select>
                    </td>
                </tr>
            </table>

            <div id="policyConfiguration" style="<%= style%>">
		<fieldset>
			<legend>Global</legend>
			  <table width="100%" border="0" cellpadding="0" cellspacing="0">
			     <tr>
				  <td colspan="2">&nbsp;</td>
			     </tr>
			     <tr>
			        <td nowrap="nowrap">Maximum Concurrent Accesses</td>
				  <td width="100%"><input id="maxAccess" name="maxConcAcc" type="text" size="14" value="<%=maxAccesses%>"/></td>
			     </tr>
			     <tr>
				  <td colspan="2">&nbsp;</td>
			     </tr>
			  </table>
                    <table class="styled" id="dataTable">
                        <thead>
                            <tr>
                                <th>Range</th>
                                <th>Type</th>
                                <th>Max Request Count</th>
                                <th>Unit Time (ms)</th>
                                <th>Prohibit Time Period (ms)</th>
                                <th>Access</th>
                                <th>&nbsp;</th>
                            </tr>
                        </thead>
                        <%= htmlString%>
                    </table>
			  <table width="100%" border="0" cellpadding="0" cellspacing="0">
				<tr>
				   <td class="addNewSecurity"><a href="#" onclick="addRow();"><img src="images/add.gif" border="0" /></a></td>
				   <td class="addNewSecurity" width="100%"><a href="#" onclick="addRow();">Add New Entry</a></td>
				</tr>
			  </table>

                    <p>&nbsp;</p>

                    <div>
                        <input type="button" value="Finish" onclick="submitForm();"/>
                        <input type="button" value="Reset" onclick="resetForm();"/>
                        <input type="button" value="Default" onclick="loadDefault();"/>
                        <input type="button" value="Clear" onclick="clearAll();"/>
                        <a id="cancelButton" href="#"><input type="button" value="Cancel"/></a>
                    </div>
          	</fieldset>
            </div>
        </form>

    </div>
</div>

<div id="alertMessageBox" style="display:none;position:absolute;z-index: 600;">
    <!--the message area-->
    <p id="alertMessageBoxMessageArea"></p>
    <!-- the button area-->
    <p id="alertButton" align="right">
        <input id="alertBoxButton" type="button"
               value="  OK  "
               onclick="document.getElementById('alertMessageBox').style.display='none';return false;"/>
    </p>
</div>
</body>
</html>
