<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%@ page import="org.apache.commons.fileupload.FileItem" %>
<%@ page import="org.apache.commons.fileupload.disk.DiskFileItem" %>
<%@ page
        import="org.apache.commons.fileupload.servlet.ServletFileUpload" %>
<%@ page import="org.apache.commons.fileupload.servlet.ServletRequestContext" %>
<%@ page import="org.wso2.carbon.security.ui.client.KeyStoreAdminClient" %>
<%@ page
        import="org.wso2.carbon.security.ui.jsp.SecurityUIUtil" %>
<%@ page import="java.util.List" %>

<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <link href="../../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript" src="../../main/admin/js/breadcrumbs.js"
            type="text/javascript"></script>
    <script language="javascript" src="../../main/admin/js/cookies.js"
            type="text/javascript"></script>
    <script language="javascript" src="../../main/admin/js/main.js"></script>
    <script language="javascript" src="../extensions/core/js/vui.js"></script>
    <title>WSO2 Carbon - Security Configuration</title>
</head>

<script language="JavaScript">
    
    function doValidation() {
      
        reason = validateEmpty("keyPass");
        if (reason != "") {
            wso2.wsf.Util.alertWarning("Enter private key password");
            return false;
        }
        else{
            document.forms.keystoreFinish.submit();
        }
        
    }
    
    function setBreadcrumb() {
        generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Add-Step2");
    }
    
        function setBreadcrumb() {
            generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Add");
        }

    function doCancel() {
        goBack(2);
        location.href = 'keystore-mgt.jsp';
    }
</script>

<body onload="setBreadcrumb();">
<div id="middle">

<jsp:include page="../display-messages.jsp"/>
<div id="breadcrumbDiv" style="display:none;"></div>
<h2>Add New Keystore</h2>
<div id="formset">
            <%
                boolean isGetPrivateKey = false;
                String fileName = null;

                try {

                    if (ServletFileUpload.isMultipartContent(request)) {
                        List items = SecurityUIUtil.parseRequest(new ServletRequestContext(request));
                        String ksPassword = null;
                        String provider = null;
                        String keystoreType = null;
                        byte[] content = null;

                        for (Object item : items) {
                            DiskFileItem diskFileItem = (DiskFileItem) item;
                            String name = diskFileItem.getFieldName();
                            if (name.equals("keystoreFile")) {
                                FileItem fileItem = (FileItem) diskFileItem;
                                fileName = fileItem.getName();
                                content = fileItem.get();
                            } else if (name.equals("ksPassword")) {
                                ksPassword = new String(diskFileItem.get());
                            } else if (name.equals("provider")) {
                                provider = new String(diskFileItem.get());
                            } else if (name.equals("keystoreType")) {
                                keystoreType = new String(diskFileItem.get());
                            }
                        }

                        String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
                        KeyStoreAdminClient client = new KeyStoreAdminClient(cookie);
                        //client.addKeyStore(content, fileName, ksPassword, provider, keystoreType);

                        if (client.isPrivateKeyStore(content, ksPassword, keystoreType)) {
                            isGetPrivateKey = true;
                        }
                        
                        session.setAttribute("org.wso2.carbon.security.content", content);
                        session.setAttribute("org.wso2.carbon.security.fileName", fileName );
                        session.setAttribute("org.wso2.carbon.security.ksPassword", ksPassword);
                        session.setAttribute("org.wso2.carbon.security.provider", provider);
                        session.setAttribute("org.wso2.carbon.security.keystoreType", keystoreType);
                        
                        if(!isGetPrivateKey){

                            // todo Dimuthu. The following redirect was added as a sollution to
                            // https://wso2.org/jira/browse/DS-423 Are we gonna allow users to
                            // upload keystores that do not contain private key
                            response.sendRedirect("add-keystore-step1.jsp?msgId=MSG" +
                                    (System.currentTimeMillis() + Math.random()) +
                                    "&errorMessage=" + "The Keystore does not contain a private key." +
                                    "Please upload a keystore that contains a private key");
                            session.setAttribute("add-keystore-error", "true");
                            return;
                        }

                    }
                } catch (Exception e) {
                    response.sendRedirect("add-keystore-step1.jsp?msgId=MSG" + (System.currentTimeMillis() + Math.random()) +
                                          "&errorMessage=" + e.getMessage());
                    session.setAttribute("add-keystore-error", "true");
                    return;
                }
            %>

            <%
                if (isGetPrivateKey) {
            %>
    <form method="post" action="add-keystore-finish.jsp" name="keystoreFinish">
        <fieldset>
            <p>
                <legend>Step 2: Specify Private Key Password</legend>
            </p>
            <input type="hidden" name="keyStoreName" value="<%=fileName%>"/>
            <input type="hidden" name="addKeystore" value="true"/>
            <table>
                <tr>
                    <td>Private key password<font color="red">*</font></td>
                    <td>
                        <input type="password" name="keyPass" value=""/>
                    </td>
                </tr>
                <tr>
                    <td>&nbsp;</td>
                    <td>
                        <input type="button" value="&lt; Back" onclick="history.back()"/>&nbsp;&nbsp;
                        <input type="button" value="Finish" onclick="doValidation();"/>&nbsp;&nbsp;
                        <input type="button" value="Cancel" onclick="doCancel();"/>
                    </td>
                </tr>
            </table>
            <br/>

            <%
                }
            %>
        </fieldset>
    </form>
</div>
<p>&nbsp;</p>

<p>&nbsp;</p>
</div>
<div id="alertMessageBox" style="display:none;position:absolute;z-index: 600;">
    <!--the message area-->
    <p id="alertMessageBoxMessageArea"></p>
    <!-- the button area-->
    <p id="alertButton" align="right">
        <input id="alertBoxButton" type="button"
               value="  OK  "
               onclick="document.getElementById('alertMessageBox').style.display='none';return false;"/>
    </p>
</div>
</body>
</html>