<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%@page import="org.wso2.carbon.security.ui.client.KeyStoreAdminClient"%>
<%@page import="org.wso2.carbon.security.ui.keystore.xsd.KeyStoreData"%>
<%@page import="org.wso2.carbon.security.ui.client.UserGroupAdminClient"%>
<%@page import="org.wso2.carbon.security.ui.usergroup.xsd.UserGroupData"%>
<%@page import="org.wso2.carbon.security.ui.client.SecurityAdminClient"%>
<%@page import="org.wso2.carbon.security.ui.config.xsd.SecurityScenarioData"%>
<%@page import="org.wso2.carbon.security.ui.config.xsd.SecurityConfigData"%>
<%@page import="java.util.List"%>
<%@page import="java.util.ArrayList"%>
<%@page import="java.util.Arrays"%>
<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<link href="../../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
<script language="javascript" src="../extensions/core/js/vui.js"></script>
<script language="javascript" src="../../main/admin/js/main.js" type="text/javascript"></script>
<script language="javascript" src="../../main/admin/js/breadcrumbs.js"></script>
<script language="javascript" src="../../main/admin/js/cookies.js"></script>
<title>WSO2 Carbon - Security Configuration</title>

<script language="JavaScript">
function doValidation(){
    goBack(1);
    var isChecked = false;
    isChecked = isAtleastOneCheckedIfExisting("userGroups");
    if(isChecked != true){
        wso2.wsf.Util.alertWarning("Please select at leaset one user group");
        return false;
    }
    
    isChecked = isAtleastOneCheckedIfExisting("trustStore");
    if(isChecked != true){
        wso2.wsf.Util.alertWarning("Please select at least one trust store");
        return false;
    }
    
    return true;
}


function setBreadcrumb() {
    generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Activate Security");
}

</script> 
</head>
<body onload="setBreadcrumb();">
<div id="middle">
<div id="breadcrumbDiv" style="display:none;"></div>
<h2>Activate Security</h2>
<div id="formset">
<form method="post" action="add-security.jsp" name="dataForm" onsubmit="return doValidation()">
<input type="hidden" name="scenarioId" id="scenarioId" value="<%=request.getParameter("scenarioId")%>"/>
<%
try{

    
    String scenId = request.getParameter("scenarioId");
    session.setAttribute("scenarioId", scenId);
    String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    SecurityAdminClient secClient = new SecurityAdminClient(cookie);
    SecurityScenarioData scenData = secClient.getSecurityScenario(scenId);

    String serviceName = (String)session.getAttribute("serviceName");

    SecurityConfigData configData = secClient.getSecurityConfigData(serviceName, scenId);
    //place holders for existing configs    
    String curr_pvtks = "";
    List<String> curr_tstks = new ArrayList<String>();
    List<String> curr_ugs = new ArrayList<String>();
    if(configData != null){
        if(configData.getPrivateStore()!=null){
            curr_pvtks = configData.getPrivateStore();
        }
        
        if(configData.getTrustedKeyStores() != null &&
                configData.getTrustedKeyStores().length>0 &&
                configData.getTrustedKeyStores()[0]!=null){
            curr_tstks = Arrays.asList(configData.getTrustedKeyStores());
        }
        
        if(configData.getUserGroups() != null &&
                configData.getUserGroups().length> 0 &&
                configData.getUserGroups()[0]!=null){
            curr_ugs = Arrays.asList(configData.getUserGroups());
        }
        
     }

    
    
    String category = scenData.getCategory();

    if(category.contains("ut")){
        UserGroupData[] groupData = null;
        UserGroupAdminClient client = new UserGroupAdminClient(cookie);
        groupData = client.getUserGroups();
%>
<fieldset>
<legend>User Groups</legend>
<%
    if(groupData != null){
        
        
        
        
        
        for(UserGroupData data : groupData){ 
            if(data != null){ //Confusing!!. Sometimes a null object comes. Maybe a bug in Axis!!
                String checked = "";
                if(curr_ugs.contains(data.getName())){
                    checked="checked=\"checked\"";
                }
%>
    <p><input type="checkbox" name="userGroups" value="<%=data.getName()%>" <%=checked%>/> <%=data.getName()%></p>
<%
            }
        }
    }
%>
</fieldset>
<%
}
if(category.contains("keystore")){
    KeyStoreData[] datas = null;
    KeyStoreAdminClient client = new KeyStoreAdminClient(cookie);
    datas = client.getKeyStores();
%>
<fieldset>
<legend>Trusted Key Stores</legend>
<%
    if(datas != null){
        for( KeyStoreData data : datas ) {
            if(data != null){ //Confusing!!. Sometimes a null object comes. Maybe a bug in Axis!!
                String checked = "";
                if(curr_tstks.contains(data.getKeyStoreName())){
                    checked="checked=\"checked\"";
                }
%>
<p><input type="checkbox" name="trustStore" value="<%=data.getKeyStoreName()%>" <%=checked%>/> <%=data.getKeyStoreName()%></p>
<% 
            }
        }
    }
    %>
</fieldset>
<fieldset>
<legend>Private key store</legend>
<select name="privateStore" >
    <%
    if(datas != null){
        for( KeyStoreData data : datas ) {
            if(data != null && data.getPrivateStore()){
                String selected = "";
                if(data.getKeyStoreName().equals(curr_pvtks)){
                    selected = "selected=\"selected\"";
                }
                
                %>
                <option value ="<%=data.getKeyStoreName()%>" <%=selected %>><%=data.getKeyStoreName()%></option>
                <%   
           }
        }
    }
}
    %>
</select>
</fieldset>
<%
}catch(Exception e){
    e.printStackTrace();
    %>
    <strong>An error occurred!</strong>
    <p>Error message is : <%=e.getMessage()%> </p>
    <%
}
%>
<p></p>
<input type="submit" value="Finish"/>
<%

%>
</form>
</div>
</div>
<div id="alertMessageBox" style="display:none;position:absolute;z-index: 600;">
    <!--the message area-->
    <p id="alertMessageBoxMessageArea"></p>
    <!-- the button area-->
    <p id="alertButton" align="right">
        <input id="alertBoxButton" type="button"
               value="  OK  "
               onclick="document.getElementById('alertMessageBox').style.display='none';return false;"/>
    </p>
</div>
</body>
</html>