<!--
/*
* Copyright (c) 2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
* http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/
-->

<%@ page import="org.wso2.carbon.caching.service.CachingAdminServiceStub" %>
<%@ page import="org.wso2.carbon.caching.xsd.CachingConfigData" %>
<%@ page import="org.wso2.carbon.registry.service.RegistryService" %>
<%@ page import="org.wso2.registry.Resource" %>
<%@ page import="org.wso2.registry.Registry" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.axis2.context.ConfigurationContextFactory" %>
<%@ page import="org.apache.axis2.client.Options" %>
<%@ page import="org.apache.axis2.client.ServiceClient" %>
<%
    RegistryService registryService = (RegistryService) config
            .getServletContext().getAttribute("registry");
    Registry systemRegistry = registryService.getSystemRegistry();
    Resource resource = systemRegistry.get("/carbon/connection/props");
    String servicePath = resource.getProperty("service-path");
    String contextRoot = resource.getProperty("context-root");
    String host = resource.getProperty("host-name");
    contextRoot = contextRoot.equals("/") ? "" : contextRoot;
    host = (host == null) ? "localhost" : host;
    String httpPort = System.getProperty("carbon.https.port");

    ConfigurationContext cc = ConfigurationContextFactory.createConfigurationContextFromFileSystem(null, null);
    CachingAdminServiceStub stub = new CachingAdminServiceStub(cc, "https://" + host + ":" +
                                                                   httpPort + "/" + contextRoot + servicePath + "/CachingAdminService");

    String cookie = (String)session.getAttribute(org.wso2.carbon.utils.ServerConstants.ADMIN_SERVICE_COOKIE);
    ServiceClient client = stub._getServiceClient();
    Options option = client.getOptions();
    option.setManageSession(true);
    option.setProperty(org.apache.axis2.transport.http.HTTPConstants.COOKIE_STRING, cookie);

    String serviceName = request.getParameter("serviceName");
    boolean global = false;
    if (serviceName == null) {
        global = true;
    }
    CachingConfigData confData = new CachingConfigData();
    if (request.getParameter("enable").equals("Yes")) {
        confData.setXmlIdentifier(request.getParameter("hashField"));
        String temp = request.getParameter("timeoutField");
        if (temp != null && temp.length() != 0) {
            confData.setExpTime(Long.parseLong(temp));
        }
        temp = request.getParameter("cacheField");
        if (temp != null && temp.length() != 0) {
            confData.setMaxCacheSize(Integer.parseInt(temp));
        }
        temp = request.getParameter("msgField");
        if (temp != null && temp.length() != 0) {
            confData.setMaxMsgSize(Integer.parseInt(temp));
        }
        if (global) {
            stub.globallyEngageCaching(confData);
        } else {
            stub.enableCaching(serviceName, confData);
        }
    } else {
        if (global) {
            stub.disengageGlobalCaching();
        } else {
            stub.disableCaching(serviceName);
        }
    }
//    response.sendRedirect("index.jsp?msgId=MSG" + (System.currentTimeMillis() + Math.random()) +
//                          "&message=Successfully applied caching configuration&serviceName=" + serviceName);

    if(serviceName != null){
     response.sendRedirect("index.jsp?msgId=MSG" + (System.currentTimeMillis() + Math.random()) +
                          "&message=Successfully applied caching configuration&serviceName=" + serviceName);
    }else{
      response.sendRedirect("index.jsp?msgId=MSG" + (System.currentTimeMillis() + Math.random()) +
                          "&message=Successfully applied caching configuration");
    }
%>