<%@ page import="org.wso2.carbon.throttle.service.ThrottleAdminServiceStub" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="org.wso2.carbon.throttle.xsd.InternalData" %>
<%@ page import="org.wso2.carbon.throttle.xsd.ThrottlePolicy" %>
<%@ page import="org.wso2.carbon.registry.service.RegistryService" %>
<%@ page import="org.wso2.registry.Registry" %>
<%@ page import="org.wso2.registry.Resource" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.axis2.context.ConfigurationContextFactory" %>
<%@ page import="org.apache.axis2.client.Options" %>
<%@ page import="org.apache.axis2.client.ServiceClient" %>
<%
    RegistryService registryService = (RegistryService) config
            .getServletContext().getAttribute("registry");
    Registry systemRegistry = registryService.getSystemRegistry();
    Resource resource = systemRegistry.get("/carbon/connection/props");
    String servicePath = resource.getProperty("service-path");
    String contextRoot = resource.getProperty("context-root");
    String host = resource.getProperty("host-name");
    contextRoot = contextRoot.equals("/") ? "" : contextRoot;
    host = (host == null) ? "localhost" : host;
    String httpPort = System.getProperty("carbon.https.port");

    ConfigurationContext cc = ConfigurationContextFactory.createConfigurationContextFromFileSystem(null, null);
    ThrottleAdminServiceStub stub = new ThrottleAdminServiceStub(cc, "https://" + host + ":" +
            httpPort + "/" + contextRoot + servicePath + "/ThrottleAdminService");

    String cookie = (String) session.getAttribute(org.wso2.carbon.utils.ServerConstants.ADMIN_SERVICE_COOKIE);
    ServiceClient client = stub._getServiceClient();
    Options option = client.getOptions();
    option.setManageSession(true);
    option.setProperty(org.apache.axis2.transport.http.HTTPConstants.COOKIE_STRING, cookie);

    String service = request.getParameter("serviceName");
    boolean global = false;
    if (service == null) {
        global = true;
    }

    /**
     * If throttling is enabled on the UI, fill the configs in to an
     * Array of InternalData
     */
    try {
        if (request.getParameter("enable").equals("Yes")) {
            ArrayList<InternalData> list = new ArrayList<InternalData>();
            String value = "";
            int i = 0;
            while (value != null) {
                i++;
                InternalData temp = new InternalData();
                if (request.getParameter("data" + i + "1") == null) {
                    break;
                }
                for (int j = 1; j < 7; j++) {
                    value = request.getParameter("data" + i + "" + j);
                    if (value != null && !value.equals("")) {
                        switch (j) {
                            case 1:
                                temp.setRange(value);
                                break;
                            case 2:
                                temp.setMaxRequestCount(Integer.parseInt(value));
                                break;
                            case 3:
                                temp.setUnitTime(Integer.parseInt(value));
                                break;
                            case 4:
                                temp.setProhibitTimePeriod(Integer.parseInt(value));
                                break;
                            case 5:
                                if (value.equals("Control")) {
                                    temp.setAccessLevel(0);
                                } else if (value.equals("Deny")) {
                                    temp.setAccessLevel(1);
                                } else {
                                    temp.setAccessLevel(2);
                                }
                                break;
                            case 6:
                                temp.setRangeType(value);
                                break;
                            default:
                        }
                    }
                }
                list.add(temp);
            }

            InternalData[] data = new InternalData[list.size()];
            for (int p = 0; p < list.size(); p++) {
                data[p] = list.get(p);
            }

            //Create a ThrottlePolicy object to be sent
            ThrottlePolicy policy = new ThrottlePolicy();
            policy.setEngaged(true);
            policy.setInternalConfigs(data);
            if (request.getParameter("maxConcAcc") != null &&
                    !request.getParameter("maxConcAcc").equals("")) {
                policy.setMaxConcurrentAccesses(Integer.parseInt(request.getParameter("maxConcAcc")));
            }
            if (global) {
                stub.globallyEngageThrottling(policy);
            } else {
                stub.enableThrottling(service, policy);
            }
        } else {
            //If throttling is not enabled, send a disable call
            if (global) {
                stub.disengageGlobalThrottling();
            } else {
                stub.disableThrottling(service);
            }
        }

        if (service != null) {
            response.sendRedirect("index.jsp?msgId=MSG" + (System.currentTimeMillis() + Math.random()) +
                    "&message=Successfully applied throttling configuration&serviceName=" + service);
        } else {
            response.sendRedirect("index.jsp?msgId=MSG" + (System.currentTimeMillis() + Math.random()) +
                    "&message=Successfully applied throttling configuration");
        }

    } catch (NumberFormatException e) {
        response.sendRedirect("index.jsp?msgId=MSG" + (System.currentTimeMillis() + Math.random()) +
                "&errorMessage=Numbers you have specified in the configuration is too large&serviceName=" + service);
    }

%>