<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%@ page import="org.wso2.carbon.security.ui.client.UserStoreAdminClient" %>
<%@page import="org.wso2.carbon.security.ui.userstore.xsd.UserListData"%>
<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <link href="../../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript" src="../extensions/core/js/vui.js" type="text/javascript"></script>
    <script language="javascript" src="../../main/admin/js/breadcrumbs.js" type="text/javascript"></script>
    <script language="javascript" src="../../main/admin/js/cookies.js" type="text/javascript"></script>
    <script language="javascript" src="../../main/admin/js/main.js" type="text/javascript"></script>
    <title>WSO2 Carbon - Security Configuration</title>
    <script language="JavaScript">
        function doValidation() {
            var reason = "";
            reason += validateEmpty("groupName");

            if (reason != "") {
                wso2.wsf.Util.alertWarning('Enter a valid Group Name');
                return false;
            }
            
            reason = validateName("groupName");
            if (reason != "") {
                wso2.wsf.Util.alertWarning("Spaces are not allowed in : Group Name");
                return false;
            }

            isChecked = isAtleastOneCheckedIfExisting("userList");
            if (isChecked != true) {
                wso2.wsf.Util.alertWarning("Please select at least one user");
                return false;
            }
            
            isChecked = isAtleastOneCheckedIfExisting("selectAll");
            if (isChecked != true) {
                wso2.wsf.Util.alertWarning("Please select all users");
                return false;
            }
            return true;
        }

        function setBreadcrumb() {
            generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Add-Step2");
        }

        function doCancel() {
            goBack(2);
            location.href = 'usergroup-mgt.jsp';
        }
    </script>
</head>
<body onload="setBreadcrumb();">
<div id="middle">
    <jsp:include page="../display-messages.jsp"/>
    <div id="breadcrumbDiv" style="display:none;"></div>
    <h2>Add User Group</h2>
    <%!UserListData userList =null; %>
    <%
        String storeName = request.getParameter("storeName");
        try {
            String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            UserStoreAdminClient client = new UserStoreAdminClient(cookie);
            userList = client.getStoreUsers(storeName);
        } catch (Exception e) {
            e.printStackTrace();
        }
    %>
   <div id="formset">
       <form method="post" action="add-usergroup-finish.jsp" name="dataForm" onsubmit="return doValidation();">
    <fieldset>
        <p>
            <legend>Step 2: Specify Group Details &amp; Users</legend>
        </p>
                        <table>
                    <tr>
                        <td>Store Name<font color="red">*</font></td>
                        <td><input type="text" name="storeName" value="<%=storeName%>"
                                   readonly="readonly"/></td>
                    </tr>
                    <tr>
                        <td>Group Name<font color="red">*</font></td>
                        <td><input type="text" name="groupName"/></td>
                    </tr>
                    <tr>
                        <td>Description</td>
                        <td>
                            <textarea rows="5" cols="40" name="description"></textarea>
                        </td>
                    </tr>
                    <tr>
                        <td>Users in the Group</td>
                        <td>
                            <table>
                              <tbody>
                                <%
                                if(userList == null){
                                %>
                                <tr>
                                    <td>
                                        The user list is null. An error occured while retriving the user list from the store.
                                    </td>
                                </tr>    
                                <%
                                }else if(userList.getCriteriaOnly()){
                                %>
                                    <tr>
                                        <td>
                                            <p>Too many users to list. Please select a criteria</p>
                                            <p><input type="checkbox" name="selectAll"/>Select All</p>
                                        </td>
                                    </tr>    
                                <%    
                                }else{
                                    String[] names = userList.getUserList();
                                    if (names != null) {
                                        for (String name : names) {
                                            if (name != null) {
                                %>
                                <tr>
                                    <td>
                                    <input type="checkbox" name="userList" value="<%=name%>"/><%=name%>
                                    </td>
                                </tr>
                                <%
                                            }
                                        }
                                    }
                                }
                                %>
                                </tbody>
                            </table>
                        </td>
                    </tr>
                    <tr>
                        <td colspan="2">&nbsp;</td>
                    </tr>
                    <tr>
                        <td>&nbsp;</td>
                        <td>
                            <input type="button" value="< Back" onclick="history.back()"/>
                            <input type="submit" value="Finish"/>
                            <input type="button" value="Cancel" onclick="doCancel();"/>
                        </td>
                    </tr>
                </table>
    </fieldset>
           </form>
       </div>
</div>
<div id="alertMessageBox" style="display:none;position:absolute;z-index: 600;">
    <!--the message area-->
    <p id="alertMessageBoxMessageArea"></p>
    <!-- the button area-->
    <p id="alertButton" align="right">
        <input id="alertBoxButton" type="button"
               value="  OK  "
               onclick="document.getElementById('alertMessageBox').style.display='none';return false;"/>
    </p>
</div>
</body>
</html>