<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
"http://www.w3.org/TR/html4/strict.dtd">
<%@ page import="org.wso2.carbon.security.ui.client.UserStoreAdminClient" %>
<%@ page import="org.wso2.carbon.security.ui.userstore.xsd.StoreProperty" %>
<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<html>
<head>
    <title>WSO2 Carbon - Security Configuration</title>
    <link href="../../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript" src="../extensions/core/js/vui.js"></script>
    <script language="javascript" src="../../main/admin/js/breadcrumbs.js"></script>
    <script language="javascript" src="../../main/admin/js/cookies.js"></script>
    <script language="javascript" src="../../main/admin/js/main.js"></script>
    <%!String requiredFields=" ";%>
    
     <script language="JavaScript">
     
        function setBreadcrumb() {
            generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Add-step2");
        }

        function doCancel() {
            goBack(2);
            location.href='userstore-mgt.jsp';
        }
    </script>
</head>

<body onload="setBreadcrumb();">
<div id="middle">
    <jsp:include page="../display-messages.jsp"/>
    <div id="breadcrumbDiv" style="display:none;"></div>
    <h2>Add New User Store</h2>
    <%
        String storeType = request.getParameter("storeType");
        StoreProperty[] props = null;
        try {
            String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            UserStoreAdminClient client = new UserStoreAdminClient(cookie);
            props = client.getStoreTypeProperties(storeType);
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (props != null) {
    %>
    <div id="formset">
        <form action="add-userstore-finish.jsp" method="post" onsubmit="return doValidation();">
    <fieldset>
        <legend>Step 2: Set User Store Properties</legend>

                <table cellspacing="0" cellpadding="0" border="0" width="100%">
                    <tr>
                        <td>User Store Name <font color="red">*</font></td>
                        <td><input type="text" name="storeName"></td>
                        <td width="100%">&nbsp;</td>
                    </tr>
                    <tr>
                        <td>Description</td>
                        <td colspan="2"><textarea rows="5" cols="40" name="storeDescription"></textarea></td>
                    </tr>
                    <tr>
                        <td>Store Type</td>
                        <td><input type="text" name="storeType" value="<%=storeType%>"
                                   readonly="readonly"></td>
                        <td>&nbsp;</td>
                    </tr>
                    <%
                        StringBuffer buff = new StringBuffer();
                        for (StoreProperty prop : props) {
                    %>
                    <tr>
                        <%
                        if(prop.getRequiredField()){
                            buff.append("\"");
                            buff.append(prop.getName());
                            buff.append("\"");
                            buff.append(", ");
                            %>
                            <td><%=prop.getLabelName()%><font color="red">*</font></td>
                            <%
                        }else{
                            %>
                            <td><%=prop.getLabelName()%></td>
                            <%
                        }
                        %>
                        
                        <td><input type="<%=prop.getInputType()%>" name="<%=prop.getName()%>"/></td>
                        <td class="helpNewSecurity"><img src="../extensions/core/images/help.gif" alt="<%=prop.getHelpText()%>" onclick="showHelpMessage('<%=prop.getHelpText()%>')" / ></td>
                    </tr>
                    <%
                    }
                    if(buff.length()>2){
                        String temp = buff.toString();
                        requiredFields = temp.substring(0, temp.length()-2);
                    }
                    %>
                    <tr>
                        <td colspan="3">&nbsp;</td>
                    </tr>
                    <tr>
                        <td>&nbsp;</td>
                        <td colspan="2">
                            <input type="button" value="< Back" onclick="history.back();"/>&nbsp;&nbsp;
                            <input type="submit" value="Finish"/>&nbsp;&nbsp;
                            <input type="button" value="Cancel" onclick="doCancel();"/>
                        </td>
                    </tr>
                </table>

    </fieldset>
   </form>
  </div>
    <%
    
        }
    %>
</div>
<script language="JavaScript">
    function doValidation(){
        var reason = "";
        reason = validateEmpty("storeName");
        if (reason != "") {
            wso2.wsf.Util.alertWarning("Enter a valid : Store Name");
            return false;
        }
        
        reason = validateName("storeName");
        if (reason != "") {
            wso2.wsf.Util.alertWarning("Spaces are not allowed in : Store Name");
            return false;
        }
        
        var required = new Array (<%=requiredFields%>);
        var counter = 0;
        
        for (counter=0; counter < required.length; counter++) {
            var name = required[counter];
            reason += validateEmpty(name);
        }
        
        if (reason != "") {
            wso2.wsf.Util.alertWarning("Enter a valid : "+reason);
            return false;
        }
        
        return true;
    }

    function showHelpMessage(message){
    	wso2.wsf.Util.alertMessage(message);
    }
</script>
<div id="alertMessageBox" style="display:none;position:absolute;z-index: 600;">
    <!--the message area-->
    <p id="alertMessageBoxMessageArea"></p>
    <!-- the button area-->
    <p id="alertButton" align="right">
        <input id="alertBoxButton" type="button"
               value="  OK  "
               onclick="document.getElementById('alertMessageBox').style.display='none';return false;"/>
    </p>
</div>
</body>
</html>